#include <errno.h>	/* errno */
#include <stdio.h>	/* fprintf */
#include <sys/types.h>	/* socket interface */
#include <unistd.h>
#include <fcntl.h>	/* open() flags */
#include <sys/time.h>	/* struct timeval */


struct watcher {
	struct timeval last_active_time;
	int fd, ready;
	char *path;

	/* other data follows... */
};

void init_watcher(struct watcher *wp, int fd, char *path)
{
	wp->fd = fd;
	wp->path = path;
	gettimeofday(&wp->last_active_time, NULL);
}


/*
 * ƻ뤹륹ȥ꡼Τɤ⤬ɤ߹ԲĤʤȤˡ
 * selectǵƤǤĹԤ
 * Ǥ2.5
 */
#define WAIT_MAX_SEC  2
#define WAIT_MAX_USEC 500000

void update_active_time(int n, struct watcher w_ary[])
{
	int i, maxfd;
	struct timeval tv;
	fd_set ready;

	maxfd = 0;
	tv.tv_sec = WAIT_MAX_SEC;
	tv.tv_usec = WAIT_MAX_USEC;
	FD_ZERO(&ready);
	for(i = 0; i < n; i++)
		if(w_ary[i].fd >= 0) {
			FD_SET(w_ary[i].fd, &ready);
			if(w_ary[i].fd > maxfd) maxfd = w_ary[i].fd;
		}

  do_polling:
	i = select(maxfd + 1, &ready, NULL, NULL, &tv);
	if(i < 0) {
		/* ʥˤǤϡselectľ */
		if(errno == EINTR) goto do_polling;
		/* ¾Υ顼ϡ"٤ɤ߹Բ" */
		else FD_ZERO(&ready);
	}

	gettimeofday(&tv, NULL);
	for(i = 0; i < n; i++) {
		/* ե뤬ץ󤵤Ƥơɤ߹߲ĤĴ٤ */
		if(w_ary[i].fd >=0 && FD_ISSET(w_ary[i].fd, &ready)) {
			w_ary[i].ready = 1;
			w_ary[i].last_active_time = tv;
		} else {
			w_ary[i].ready = 0;
		}
	}
}


#define N 8
#define READ_SIZE 4

int main(int argc, char *argv[])
{
	int i, fd, tmp, open_files;
	char buf[READ_SIZE];
	struct watcher wa[N];
	struct timeval now;

	open_files = 0;
	for(i = 1; i < argc && i < N; i++) {
		fd = open(argv[i], O_RDONLY | O_NONBLOCK);
		init_watcher(&wa[open_files], fd, argv[i]);

		fprintf(stderr, "opened %s with fd %d in slot %d\n",
			argv[i], fd, open_files);
		++open_files;
	}

	for(;;) {
		update_active_time(open_files, wa);

		gettimeofday(&now, NULL);
		for(i = 0; i < open_files; i++) {
			if(wa[i].ready) {
				/*
				 * ǡɤ
				 */
				fprintf(stderr, "rdy   ,");
				tmp = read(wa[i].fd, buf, sizeof(buf));

				/*
				 * EOFʤΤǡեĤ
				 */
				if(tmp == 0) {
					close(wa[i].fd);
					wa[i].fd = -1;
				}
			} else if(wa[i].fd >= 0) {
				/*
				 * ץ󤵤Ƥ뤬
				 * ޤĹʤ饿ॢȤˤ
				 * 顼ȤưäƤ褤
				 */
				fprintf(stderr, "idle%2ld,",
					(long)(now.tv_sec - wa[i].last_active_time.tv_sec));
			} else {
				/* ץ󤵤Ƥʤ */
				fprintf(stderr, "closed,");
			}
		}
		fprintf(stderr, " at time %8.3fs\n",
			now.tv_sec % 1000 + now.tv_usec / 1000000.0);
	}
}
