#include <sys/types.h>
#include <signal.h>

#include <fcntl.h>	/* F_SETOWN */
#include <unistd.h>	/* getpid() */
#include <errno.h>	/* errno */
#include <string.h>	/* strerror() */
#include <stdio.h>	/* fprintf() */

#if defined(__sun__)
#include <stropts.h>	/* STREAMS */
#include <sys/conf.h>
#endif

#include "sockutil.c"




#define N 8
#define READ_SIZE 4


static void sigio_catcher(int sig)
{
	/* SIGIOϥɥ
	 * ⤷ʥϥɥǤʤ餫ΥǡԤϡ
	 * դ뤳 */
	fprintf(stderr, "debug: caught SIGIO\n");
}


static int set_sigio_catcher(void)
{
	struct sigaction act;

	sigemptyset(&act.sa_mask);
	act.sa_handler = sigio_catcher;
	act.sa_flags = 0;
	return sigaction(SIGIO, &act, NULL);
}

static void set_pollable(int fd)
{
#if defined(__sun__)
	/* Solaris: see man streamio */
	if(ioctl(fd, I_SETSIG, S_MSG | S_RDNORM))
		perror("ioctl(I_SETSIG)");
#else /* maybe POSIX */
	int oldflags;

	oldflags = fcntl(fd, F_GETFL, 0);
	if(oldflags != -1)
		fcntl(fd, F_SETFL, oldflags | O_ASYNC);
	if(fcntl(fd, F_SETOWN, getpid()) < 0)
		perror("fcntl(F_SETOWN)");
#endif
}


int main(int argc, char *argv[])
{
	int sock, n;
	sigset_t sigset;
	char buf[32];

	sock = open_tcpsock_as_client("localhost", "9200");
	set_pollable(sock);
	set_sigio_catcher();

	sigemptyset(&sigset);
	for(;;) {
		sigsuspend(&sigset);	/* Υʥ뤬Ϥޤ̲ */
		fprintf(stderr, "debug: sigsuspend() returned\n");

		n = read(sock, buf, sizeof(buf));
		if(n == 0) {
			/* եν */
			break;
		} else if(n < 0) {
			/* 顼 */
			fprintf(stderr,
				"read() failed: code=%d, errno=%d, reason=%s\n",
				n, errno, strerror(errno));
			break;
		} else if(n > 0) {
			/* ɤ߹᤿ */
			fprintf(stderr, "%d bytes recieved, message was: %.*s\n",
				n, n, buf);
		}
	}
	return 0;
}
