#include <stdlib.h>	/* atoi */
#include <errno.h>	/* perror */
#include <stdio.h>	/* fprintf */

#include <netdb.h>	/* get{host,serv}byname() */
#include <netinet/in.h>	/* IN_ADDR_* macro, struct sockaddr_in */

#include <sys/types.h>	/* socket interface */
#include <sys/socket.h>

#include <unistd.h>
#include <fcntl.h>	/* open() flags */

#include <sys/time.h>	/* struct timeval */

#ifdef HAVE_POLL
#include <sys/poll.h>	/* poll() */
#endif

#define preturn(s) do{perror(s); return -1;}while(0)


/*
 * ѤΥåȤ򳫤
 */
int open_tcpsock_as_server(char *listen_port)
{
	int sock;
	struct servent *svcp;
	struct sockaddr_in myname;

	sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock < 0) preturn("socket");

	/* ΥåȤ³դ륢ɥ쥹ꤹ */
	memset(&myname, 0, sizeof myname);
	myname.sin_family = AF_INET;		/* դ̾ */
	myname.sin_addr.s_addr = INADDR_ANY;	/* դ륢ɥ쥹 */
	if((svcp = getservbyname(listen_port, "tcp")) == NULL)
		myname.sin_port = htons(atoi(listen_port));
	else
		myname.sin_port = svcp->s_port;

	if(bind(sock, (struct sockaddr*)&myname, sizeof myname) < 0)
		preturn("bind");

	/* åȤ³դ⡼ɤ */
	if(listen(sock, 5) < 0)
		preturn("listen");

	return sock;
}


/*
 * 饤ѤΥåȤ򳫤
 */
int open_tcpsock_as_client(char *server_host, char *server_port)
{
	int sock;
	struct servent *sp;
	struct hostent *hp;
	struct sockaddr_in peername;

	/* ΥåȤ³륢ɥ쥹ꤹ */
	memset(&peername, 0, sizeof peername);
	peername.sin_family = AF_INET;
	if((hp = gethostbyname(server_host)) == NULL) {
		fprintf(stderr, "gethostbyname(\"%s\"): unknown host\n",
			server_host);
		return -1;
	}
	memcpy(&peername.sin_addr, hp->h_addr, hp->h_length);

	/* ݡֹ */
	if((sp = getservbyname(server_port, "tcp")) == NULL)
		peername.sin_port = htons(atoi(server_port));
	else
		peername.sin_port = sp->s_port;

	/* ³ */
	sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock < 0)
		preturn("socket");
	if(connect(sock, (struct sockaddr*)&peername, sizeof(peername)) < 0)
		preturn("connect");
	return sock;
}


/*
 * ե뵭һҤɤ߹߲ǽɤĴ٤
 * ֤: 0=Բ 1=ǽ -1=顼
 */
int check_readable(int fd)
{
	fd_set ready;
	struct timeval tv;

  start:
	tv.tv_sec = tv.tv_usec = 0;	/* Ϥ˽λ */
	FD_ZERO(&ready);
	FD_SET(fd, &ready);
	if(select(fd + 1, &ready, NULL, NULL, &tv) < 0) {
		/* ʥˤselect()Ǥ̵뤹 */
		if(errno == EINTR)
			goto start;
		else
			return -1;
	}
	return FD_ISSET(fd, &ready) ? 1 : 0;
}


#ifdef HAVE_POLL
/*
 * ե뵭һҤɤ߹߲ǽɤĴ٤
 * ֤: 0=Բ 1=ǽ -1=顼
 */
int poll_readable(int fd)
{
	struct pollfd fd_ary[1];

  start:
	fd_ary[0].fd = fd;
	fd_ary[0].events = POLLIN;	/* ɤ߹߲ǽ֤Ĵ */

	if(poll(fd_ary, sizeof(fd_ary), 0) < 0) {
		/* ʥˤpoll()Ǥ̵뤹 */
		if(errno == EINTR)
			goto start;
		else
			return -1;
	}
	return fd_ary[0].revents & (POLLIN | POLLHUP);
}
#endif HAVE_POLL


/*
 * ѤΥåȤcloseƤ⤹
 * ƱݡȤǥץǤ褦ˤ
 */
int set_sockopt_reuseaddr(int sock)
{
	int opt = 1;

	if(setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (void*)&opt, sizeof opt) < 0)
		preturn("setsockopt(REUSEADDR)");
	return sock;
}


/*
 * ե뵭һҤ֥å󥰥⡼ɤꤹ
 */
int set_nonblocking_mode(int fd)
{
	int oldval;

	oldval = fcntl(fd, F_GETFL, 0);
	if(oldval < 0)
		preturn("fcntl(F_GETFL)");

	oldval |= O_NONBLOCK;
	if(fcntl(fd, F_SETFL, oldval) < 0)
		preturn("fcntl(F_SETFL, O_NONBLOCK");

	/* : O_NDELAYO_NONBLOCKƱ褦˻Ȥޤ
	 * ʾѤƤޤ */

	return fd;
}

